module OkCrypt.Exception
  ( ExceptionOkCrypt (..),
  )
where

import OkStd

-- | Exceptions that could be raised in the library functions
data ExceptionOkCrypt
  = -- | Raised when library initialization fails
    ExceptionInitializationFailed
  | -- | @ExceptionLibsodium errCode@ represents Libsodium library error
    ExceptionLibsodium Int
  | -- | Returned when the data passed to various conversion functions does not have expected length
    ExceptionInvalidLength
  deriving (Eq, Show)

instance Exception ExceptionOkCrypt
