module OkStd.Text
  ( toHexString,
    toText,
    fromText,
  )
where

import Data.ByteString (ByteString)
import Data.ByteString.Builder (byteStringHex, toLazyByteString)
import qualified Data.ByteString.Lazy as LBS
import Data.Function ((.))
import Data.Text (Text, pack, unpack)
import Data.Text.Encoding (decodeUtf8)
import GHC.Types (Char)

-- | Converts given 'ByteString' to hexadecimal 'Text'
toHexString :: ByteString -> Text
toHexString = decodeUtf8 . LBS.toStrict . toLazyByteString . byteStringHex

-- | Packs String to Text
toText :: [Char] -> Text
toText = pack

-- | Unpacks Text into String
fromText :: Text -> [Char]
fromText = unpack