Name:    okvault
Version: 1.0.0.2
Release: 1%{?dist}
Summary: Web-application for managing passwords and secrets

# okvault: EUPL 1.2
# tachyons: MIT
# libsodium.js: ISC
# libsodium: ISC
# sqlite: Public Domain
# Inter: OFL
License: EUPL 1.2 and MIT and ISC and OFL and Public Domain
URL:     https://www.nkly.me/projects/okvault

BuildRequires: libsodium-devel >= 1.0.18
BuildRequires: sqlite-devel >= 3.36.0
BuildRequires: zlib-devel >= 1.2.11

# For installing a systemd unit
BuildRequires: systemd

# For creating user
Requires(pre): shadow-utils

# For running 'okvault init' during post-processing
Requires(post): util-linux

Requires: libsodium >= 1.0.18
Requires: sqlite >= 3.36.0
Requires: zlib >= 1.2.11
Requires: groff-base

%description
OkVault is a web-application for managing passwords, bank cards, and other
secret information.

%build
cabal build -f embed-resources -O2 okvault

%install
mkdir -p %{buildroot}%{_libexecdir}
install -p -m 0755 "$(cabal list-bin -O2 exe:okvault)" %{buildroot}%{_libexecdir}/okvault
strip --strip-unneeded %{buildroot}%{_libexecdir}/okvault

mkdir -p %{buildroot}%{_bindir}
install -p -m 0755 okvault/dist/okvault %{buildroot}%{_bindir}/okvault

mkdir -p %{buildroot}%{_mandir}/man1
install -p -m 0644 okvault/man/okvault.1 %{buildroot}%{_mandir}/man1/okvault.1

mkdir -p %{buildroot}%{_unitdir}
cp -a okvault/dist/okvault.service %{buildroot}%{_unitdir}

mkdir -p %{buildroot}%{_sharedstatedir}/okvault

%pre
getent group okvault >/dev/null || groupadd -r okvault
getent passwd okvault >/dev/null || \
    useradd -r -g okvault -d %{_sharedstatedir}/okvault -s /sbin/nologin \
    -c "Account for OkVault service" \
    okvault
exit 0

%post
%systemd_post okvault.service
runuser -u okvault -- %{_bindir}/okvault init

%preun
%systemd_preun okvault.service

%postun
%systemd_postun_with_restart okvault.service

%files
%{_bindir}/okvault
%{_libexecdir}/okvault
%{_mandir}/man1/okvault.1*
%{_unitdir}/okvault.service
%attr(0755,okvault,okvault) %dir %{_sharedstatedir}/okvault/

%changelog
* Mon Jun 13 2022 Nikolai Obedin <dev@nkly.me> - 1.0.0.2-1
- Update to 1.0.0.2

* Thu Feb 17 2022 Nikolai Obedin <dev@nkly.me> - 1.0.0.1-1
- Update to 1.0.0.1

* Sat Jan 29 2022 Nikolai Obedin <dev@nkly.me> - 1.0.0.0-1
- Package the 1st version
