module OkVault.Actions.Error
  ( showNotFoundPage,
    showInsecureRequestPage,
    showMalformedRequestPage,
  )
where

import qualified Network.HTTP.Types as HTTP
import OkVault.Actions.Shared

showNotFoundPage :: Action
showNotFoundPage =
  showErrorPage HTTP.status404 "Not Found" "The page you're looking for was not found"

showInsecureRequestPage :: Action
showInsecureRequestPage =
  showErrorPage HTTP.status412 "Insecure Request" "This server requires all requests to go via HTTPS"

showMalformedRequestPage :: Action
showMalformedRequestPage =
  showErrorPage HTTP.status400 "Bad Request" "The request you've sent is malformed."
