module OkVault.Actions.Index
  ( showIndexPage,
  )
where

import qualified Network.HTTP.Types as HTTP
import OkStd
import OkVault.Actions.Shared
import OkVault.Context
import qualified OkVault.Models.Item as Item
import qualified OkVault.Models.User as User
import qualified OkVault.Templates as Templates

showIndexPage :: Action
showIndexPage =
  currentUser >>= \case
    Just u
      | not $ User.hasKeys u ->
        redirectTemporarily "/first-time"
    Nothing ->
      redirectTemporarily "/auth/login"
    Just u -> do
      items <- withDB $ Item.findAllByUserID (User.id u)
      showHTML HTTP.status200 $ Templates.itemsList u items
