module OkVault.Config (configKeys) where

import OkStd

configKeys :: [(Text, (Text, Text))]
configKeys =
  [ ( "host",
      ("127.0.0.1", "Host to bind the server to")
    ),
    ( "port",
      ("13701", "Port to bind the server to")
    ),
    ( "base-url",
      ("http://localhost", "Base URL where OkVault is going to be hosted. Used in links and cookies.")
    ),
    ( "allow-insecure",
      ("no", "Allows accepting requests over HTTP when set to 'yes'")
    ),
    ( "sendmail",
      ("sendmail", "Path to a sendmail-compatible MTA. Used to send login codes and other emails.")
    ),
    ( "email-address",
      ("okvault@localhost", "Email address to use in the 'From:' field when sending message")
    ),
    ( "debug",
      ("no", "Prints debug messages when set to 'yes'")
    )
  ]
