class FirstTimePage {
  static exec() {
    _.onInput('confirmation', evt =>
      _.withElt('confirmation', e => {
        e.setCustomValidity('');
        e.checkValidity();
        if (!e.validity.valid) {
          e.setCustomValidity(e.validationMessage);
        } else if (_.valueOf('master-password') !== e.value) {
          e.setCustomValidity('Passwords do not match');
        }
        e.reportValidity();
      }));

    _.onSubmit('form', async evt => {
      evt.preventDefault();
      try {
        const masterPassword = _.valueOf('master-password');
        const crypt = await Crypt.init();
        const salt = crypt.generateSalt();
        const masterKey = crypt.deriveKey(masterPassword, salt);
        const dataKey = crypt.encrypt(crypt.generateKey(), masterKey);
        const metadataKey = crypt.encrypt(crypt.generateKey(), masterKey);

        _.setValueOf('salt', crypt.toBase64(salt));
        _.setValueOf('data_key', dataKey);
        _.setValueOf('metadata_key', metadataKey);
        _.withElt('form', e => {
          e.action = '/first-time';
          e.method = 'POST';
          e.submit();
        });
      } catch (exc) {
        // FIXME: make a proper error message
        console.error(exc);
      }
    });
  }
}
