class Item {
  static TypeLogin = "login"
  static TypeNote = "note"
  static TypeCard = "card"
  static Types = [this.TypeLogin, this.TypeNote, this.TypeCard]

  static *fields(item) {
    for (const k in item) {
      if (!['type', 'slug'].includes(k)) {
        yield k
      }
    }
  }

  static empty(type) {
    switch (type) {
      case this.TypeLogin:
        return {
          type: type,
          name: "",
          category: "",
          note: "",
          address: "",
          login: "",
          password: "",
          totpSecret: "",
        };
      case this.TypeCard:
        return {
          type: type,
          name: "",
          category: "",
          note: "",
          cardNumber: "",
          cardholderName: "",
          expiryDate: "",
          securityCode: "",
          pinCode: "",
        };
      case this.TypeNote:
        return {
          type: type,
          name: "",
          category: "",
          note: "",
        };
      default:
        throw new Error(`Invalid item type: '${type}'`);
    }
  }
}
