class MasterPasswordPrompt {
  static showIfNeeded(vault) {
    if (!vault.isLocked) {
      _.show('page');
      return;
    }

    _.hide('page');
    _.show('master-password-prompt');

    _.onInput('master-password', evt =>
      _.elt('master-password').setCustomValidity(''));

    _.onSubmit('master-password-form', evt => {
      evt.preventDefault();
      if (!vault.unlock(_.valueOf('master-password'))) {
        _.withElt('master-password', e => {
          e.setCustomValidity('Invalid master password');
          e.reportValidity();
        });
        return;
      }
      _.hide('master-password-prompt');
      _.show('page');
    });
  }
}