class _ {
  static elt(id) {
    return document.getElementById(id);
  }
  static withElt(id, fn) {
    return fn(_.elt(id));
  }
  static valueOf(id) {
    return _.elt(id).value;
  }
  static setValueOf(id, value) {
    _.elt(id).value = value;
  }
  static hide(id) {
    _.elt(id).hidden = true;
  }
  static show(id) {
    _.elt(id).hidden = false;
    _.elt(id).dispatchEvent(new CustomEvent('show'));
  }
  static on(id, eventType, handler) {
    _.elt(id).addEventListener(eventType, handler);
  }
  static onSubmit(id, handler) {
    _.on(id, 'submit', handler);
  }
  static onClick(id, handler) {
    _.on(id, 'click', handler);
  }
  static onInput(id, handler) {
    _.on(id, 'input', handler);
  }
  static onShow(id, handler) {
    _.on(id, 'show', handler);
  }
  static removeAllChildrenOf(id) {
    const root = _.elt(id);
    while (root.firstChild) {
      root.removeChild(root.firstChild);
    }
  }
  static cloneTemplate(id) {
    return _.elt(id).content.cloneNode(true);
  }
  static *range(from, to) {
    if (from < to) {
      for (var i = from; i < to; i++) {
        yield i;
      }
    }
  }
  static randIntn(n) {
    return Math.floor(Math.random() * n);
  }
}
